//------------------------------------
/* The Super Kabu
/*  Written by Azuron 1991/2/8(Fri)
// Oh!X 1991-4
// V3.20以降専用
//------------------------------------

// iPadのみ
if not checkCompatible(COMPATIBLE_IPAD) then stop

if cardInit()<>0 then {
	print localizedString("カードパターンが読めません","Card data can not read.")
	end
}

//----------------------------------------------------------------
// 以下ゲーム実体
//----------------------------------------------------------------
// お約束部分
enum
	FNTSZ=16
	KEY_SPACE=' '
	KEY_OK   ='D'
	KEY_UNDO ='U'
endenum
str FONT="Migu-1M-Regular"

font(FONT,FNTSZ):// 先にフォントを設定してからwidth()を設定する
width(96):// テキスト文字フォントサイズを算出させる
// 以下テキスト描画はグラフィックモードで行う(X68のプログラムのままではグラフィックとテキストで座標が合わないので)
//width(0)
//tAtrb(ATRB_CLEAR):// グラフィックモードでテキスト文字の下地を消す

vpriority(TPAGE,GPAGE0,GPAGE1,GPAGE2,GPAGE3)
vpage(B_TPAGE+B_GPAGE0+B_GPAGE1+B_GPAGE2+B_GPAGE3)

// bitmapOpen()はページ毎に行う必要がある
apage(GPAGE3):bitmapOpen(0,0,YES)
apage(GPAGE2):bitmapOpen(0,0,YES)
apage(GPAGE1):bitmapOpen(0,0,YES)
apage(GPAGE0):bitmapOpen(0,0,YES)

// これがないと任意のタッチ座標を得られない / Need for getting any touch coordinate
setTouchArea(0,0,0,0,0,NO)

dim int	touchNo(20)	:// タッチエリア番号 / touch area number
int touchallcnt=0	:// タッチエリア数   / the number of touch area

//----------------------------------------------------------------

int i,j,k,x,y,n,bl,br,exc,basyo,oya,zero,fin
dim int card(40),hand(15),po(5),ho(5),wh(5)
dim int ma(256):// 8*32
dim int hide(5),cy(5),so(4),co(4)={3,5,7,11}
dim int match(4),jun(4),la(4),per(9)={0,0,0,0,5,10,50,80,100}
dim str nam(4)={"あなた","ねこさん","うまさん","ぶたさん"}
if not isLocalizeJapan() then {
	nam={"You","Cat","Hourse","Dog"}
}
dim int snd(2)
int mspos_x,mspos_y

for i=0 to 4
	po(i)=i:wh(i)=i-1
next

// 音声データ読み込み
for i=1 to 2
//	locate(0,35+i)
//	print "kabu"+str$(i)+".mp3";
	snd(i)=a_setPlayData("kabu"+str$(i)+".mp3")
//	print "/";snd(i)
next

jqk_cut()
repeat
	prep()
	repeat
		junban()	:/* 順番を決める
		shuffle()	:/* シャッフル
		init()		:/* 変数初期化&画面初期化
		ba_put()	:/* 場にカードを出す
		sbet3()		:/* 3人分まとめて選択＆賭ける
		deal()		:/* カードを配る
		syobu()		:/* 勝負！表示
		show()		:/* カードをオープン
		pay()		:/* 支払い
	until zero=1
	fin=result()
until fin=0

// 音声バッファー開放
for i=1 to 2
	a_end(snd(i))
next

// bitmapはページごとに確保されているので、それぞれを開放する必要がある
apage(GPAGE3):bitmapClose()
apage(GPAGE2):bitmapClose()
apage(GPAGE1):bitmapClose()
apage(GPAGE0):bitmapClose()

end

//------------------------------------

func sbet3()
/* 3人分まとめて選択＆賭ける
int i
	for i=0 to 2
		select(i)
		bet(i)
	next
endfunc

//------------------------------------

func ba_put()
/* 場にカードを出す
int i,x=80
	apage(GPAGE2)
	for i=0 to 4
		m_play(1)
		hand(i*3)=conv(card(i))
		if i=4 and oya<>0 then {
			exc=card(i):ura(x,120)
			break
		}
		cardPut(x,120,card(i),NO)
		x=x+80
		m_wait(1)
	next
endfunc

//------------------------------------

func select(w;int)
/* 賭けるカードを選択
int x,y,pl
	pl=jun(w)
	myself(w,1):/* 名前の下を塗る
	//
	apage(GPAGE1)
	flbx(400,104,447,114,co(oya),co(oya)-1)

//	repeat
//		msstat(n,n,bl,br)
//		mspos(x,y)
//		x=((x-80)\80)*80+80
//		box16X68(x-2,118,x+48,217,15,&HAAAA):cwait(1)
//		box16X68(x-2,118,x+48,217, 0)       :cwait(1)
//		basyo=(x-80)\80
//	until (bl+br<>0 and wh(basyo)=-1) or pl<>0

	if pl<>0 then {
		// プレイヤー以外(コンピューターが設定)
		AI(1,0):// ->mspos_x,mspos_yに設定される
		x=mspos_x
		y=mspos_y
		x=((x-80)\80)*80+80
		basyo=(x-80)\80
	} else {
		// プレイヤー
		setFunctionKey(0,localizedString("カード決定","Card select"),KEY_OK)
		displayFunctionKey(YES,0,0)
		kbclr()
		int touchCnt
		dim float tpoint(1)
		int x0
		x=80:x0=x
		int style=&haaaa,col=15
		repeat
			wait(0.25,NO)
			if getTouchStatus()<>TOUCH_NONE then {
				// タッチされている
				touchCnt=getTouchPoint(tpoint,1)
				x=tpoint(0)
				y=tpoint(1)
				//
				x=((x-80)\80)*80+80
				/* オリジナルではmsarea()で移動範囲が限定されているので範囲外がないが、iOS版ではこれが必須
				if x<80  then x=80
				if x>320 then x=320
				if x<>x0 then {
					box16X68(x0-2,118,x0+48,217,0):// 前の枠線を消す
				}
			}
			basyo=(x-80)\80
			// 選択枠表示
			box16X68(x-2,118,x+48,217,col,style)
			while wait(-1)=NO:endwhile
			if col=15 then col=0:style=&hffff else col=15:style=&haaaa
		until inkey()=KEY_OK and wh(basyo)=-1
		displayFunctionKey(NO)
		box16X68(x-2,118,x+48,217,0)
	}
	flbx(x,104,x+47,114,co(pl),co(pl)-1)
	wh(basyo)=pl
	wh(4)=oya
	cwait(2)
endfunc

//------------------------------------

func bet(w;int)
/* 賭ける
int x,y,mx,xx,h,pl
	pl=jun(w)
	apage(GPAGE0)
	
	int h0=match(pl):// 手持ちの本数
	y=316+pl*48
	x=104+h0*8
	apage(GPAGE2):fill16X68(104,y,x,y+33,12):apage(GPAGE0)
	cwait(2)
	if pl<>0 then {
		h=AI(2,w)
	} else {
		// X68版と同じ処理は細かすぎてタップでは無理なので、キー操作に変更する(ちょっと手抜き)
		int style=&haaaa,col=15
		int ky
		setFunctionKey(0,"-1",'-')
		setFunctionKey(1,localizedString("決定","Determin"),KEY_OK)
		setFunctionKey(2,"+1",'+')
		displayFunctionKey(YES,0,2)
		kbclr()
		h=1:// 最小選択本数
		repeat
			wait(0.25,NO)
			ky=inkey()
			switch ky
				case '-'
					if h>1 then {
						box16X68(104,y,mx,y+33,0):// 前の枠線を消す
						h=h-1
					}
					break
				case '+'
					if h<h0 and h<5 then { :// 最大5本まで
						box16X68(104,y,mx,y+33,0):// 前の枠線を消す
						h=h+1
					}
					break
				case KEY_OK
					break
			endswitch
			mx=104+h*8
			box16X68(104,y,mx,y+33,col,style)
			while wait(-1)=NO:endwhile
			if col=15 then col=0:style=&hffff else col=15:style=&haaaa
		until ky=KEY_OK
		displayFunctionKey(NO)
	}
	box16X68(104,y,mx,y+33,0):// 枠線を消す
	apage(GPAGE2):fill16X68(104,y,x,y+33,0):apage(GPAGE0)
	ho(basyo)=h
	ma_kesu1(pl,h)
	ma_disp2(h)
	myself(w+1,0)
	cwait(3)
endfunc

//------------------------------------

func deal()
/* カードを配る
int i,x=0,y=0,z,d,st=5
	for i=0 to 4
		apage(GPAGE2)
		x=x+80:y=152
		d=wh(i)
		if i=4 and oya<>0 then cardPut(x,120,exc,NO)
		m_play(1)
		if d<1 then cardPut(x,y,card(st),NO) else ura(x,y)
		hide(i)=card(st)
		hand(i*3+1)=conv(card(st))
		cy(i)=y
		if d<1 then yaku_disp(i,y)
		st=st+1
		m_wait(1)
		if d=0 then z=more(x) else z=AI(3,i)
		if z=0 then continue
		y=y+32
		apage(GPAGE1)
		m_play(1)
		cardPut(x,y,card(st),NO)
		cy(i)=y
		hand(i*3+2)=conv(card(st))
		if d<1 then yaku_disp(i,y)
		st=st+1
		m_wait(1)
	next
endfunc

//------------------------------------

func pay()
/* 支払い
int i,p,h,w
	for i=0 to 3
		p=po(i):h=ho(i):w=wh(i)
		if w=-1 then continue
		if po(4)>p then {
			ma_kesu2(i)
			ma_disp1(oya,h)
		}
		if po(4)<p then {
			ma_kesu1(oya,h)
			ma_disp1(w,h*2)
		}
		if po(4)=p then {
			ma_disp1(w,h)
			ma_kesu2(i)
		}
	next
	for i=0 to 3
		if match(i)=0 then zero=1
	next
	hitKey(NO)
//	click()
endfunc

//------------------------------------

func sort()
/* ソート
int i,j,k,a,b,c
	for i=1 to 4
		k=3
		for j=1 to 4
			a=so(k):b=so(k+1)
			if b>a then {
				so(k)=b:so(k+1)=a
				c=la(k):la(k)=la(k+1):la(k+1)=c
			}
			k=k-1
		next
	next
endfunc

//------------------------------------

func junban()
/* 順番を決める
int i,j=4,c=0
	for i=0 to 4
		if wh(j)=-1 then j=j-1:continue
		so(c)=po(j):la(c)=wh(j)
		c=c+1:j=j-1
	next
	sort()
	jun(3)=la(0)
	for i=0 to 2:jun(i)=la(i+1):next
	you_oya(0):/* 前の親を消す
	oya=jun(3)
	you_oya(1):/* 今の親にバーを表示
endfunc

//------------------------------------

func show()
/* カードをオープン
int i,x=0
	for i=0 to 4
		x=x+80
		if wh(i)<1 then continue
		yaku_disp(i,cy(i))
		m_play(1)
		cardPut(x,152,hide(i),NO)
		m_wait(1)
	next
endfunc

//------------------------------------

func syobu()
/* 勝負！表示
	apage(GPAGE0)
	if isLocalizeJapan() then {
		flbx(   204,220,308,252+20,12,13)
		sym(213,224,"勝 負！"		,2,15)
		sym(221,254,"(タップ)"	,1,15)
		click()
		fill16X68(200,218,310,270+20,0)
	} else {
		   flbx(204-4*8,220,308+6*8,252+20,12,13)
		sym(213-4*8,224,"Try your luck!",2,15)
		sym(221+2*8,254,"(Tap)",1,15)
		click()
		fill16X68(200-4*8,218,310+6*8,270+20,0)
	}
endfunc

//------------------------------------

func yaku_disp(w;int,z;int)
/* 役表示
/* 面倒と言うか固有名詞なので、ここは英語化しない
str ya
	x=(w)*80+80:y=z+98
	k=yaku_judge(w)
	switch k:	/*   12345
		case  0: ya="ﾌﾞ  ﾀ":break
		case  9: ya="ｶ  ﾌﾞ":break
		case 10: ya="ﾊ ｻ ﾐ":break
		case 11: ya="ｼｯﾋﾟﾝ":break
		case 12: ya="ｸｯﾋﾟﾝ":break
		case 13: ya="ﾅﾗﾋﾟ ":break
		case 14: ya="ｱ ﾗ ｼ":break
		default: ya=itoa(k):break
	endswitch
	apage(GPAGE2)
	flbx(x,y,x+46,y+17,14,15)
	sym((x+24)-(utf8StrWidth(ya)*8\2),y+1,ya,1,4)
endfunc

//------------------------------------

func int more(x;int)
/* もっと？
//	flbx(x,272,x+46,288,12,13)
//	sym(x+4,273,"more?",1,15)
//	click()
//	fill16X68(x,272,x+46,288,0)
//	cwait(2)
//	return(bl)

	dim str menues(1)
	str title$
	if isLocalizeJapan() then {
		title$="もう1枚？"
		menues={"はい","いいえ"}
	} else {
		title$="1More?"
		menues={"Yes","No"}
	}
	switch selectMenu(title$,menues)
		case 0
			bl=1:br=0
			break
		case 1
			bl=0:br=1
			break
	endswitch
	return(bl)
endfunc

//------------------------------------

func int AI(fu;int,w;int)
/* 人工知能
int z,xx,bx,h
	if fu=1 then {
		repeat
			x=rnd()*4
		until wh(x)=-1
		x=x*80+80
		for i=80 to x
			mspos_x=i
			mspos_y=100
			//setmspos(i,100)
			//X68ではマウスカーソルをここで設定してメイン側でmspos()で読みだしている
			i=i+9
		next
		return(x)
	}
	if fu=2 then {
		y=jun(w)*48+316
		repeat
			h=rnd()*5+1
		until match(jun(w))-h>-1
		xx=h*8+104
		for i=104 to xx
			//setmspos(xx,y)
			mspos_x=xx
			mspos_y=y
			bx=(i\8)*8
			box16X68(104,y,bx,y+33,15,&HAAAA)
			box16X68(104,y,bx,y+33, 0)
		next
		cwait(3)
		return(h)
	}
	if fu=3 then {
		z=yaku_judge(w)
		if z>8 then return(0)
		z=rnd()*per(z)
		if z=0 then return(-1)
		return(0)
	}
endfunc

//------------------------------------

func int yaku_judge(w;int)
/* 役を判定
int z,h1,h2,h3,ju=0
	z=w*3
	h1=hand(z):h2=hand(z+1):h3=hand(z+2)
	while w=4 and h3=0
		if h1<>1 and h2<>1 then break
		if abs(h1-h2)=3 then ju=11
		if abs(h1-h2)=8 then ju=12
		break
	endwhile
	if ju<>0 then po(w)=ju:return(ju)
	if h1=h3 then ju=10
	if h1+1=h2 and h1+2=h3 then ju=13
	if h1=h2 and h1=h3 and w<4 then ju=14
	if ju<>0 then po(w)=ju:return(ju)
	ju=h1+h2+h3
	ju=ju-((ju\10)*10)
	po(w)=ju
	return(ju)
endfunc

//------------------------------------

func int result()
/* 結果
int y=96
	for i=0 to 3
		so(i)=match(i):la(i)=i
	next
	sort()
	apage(GPAGE0)
	flbx(170,44,342,298,1,15)
	sym(216,52,localizedString("-結 果-","Result"),1,15)
	for i=0 to 3
		sym(200,y,utf8Mid$("１２３４",i+1,1)+"  "+nam(la(i)),1,co(la(i)))
		y=y+32
	next
	
	dim str menues(1)
	str title$
	if isLocalizeJapan() then {
		title$="もう一度、やりますか？"
		menues={"はい","いいえ"}
	} else {
		title$="Try again?"
		menues={"Yes","No"}
	}
	switch selectMenu(title$,menues)
		case 0
			bl=1:br=0
			break
		case 1
			bl=0:br=1
			break
	endswitch
	return(bl)
endfunc

//------------------------------------

func ma_disp1(w;int,hw;int)
/* マッチ表示1
int i,x,y
	apage(GPAGE0)
	x=match(w)*8+105
	y=w*48+317
	for i=1 to hw
		m_play(2)
		bitmapPut(x,y,x+7,y+31,ma)
		bitmapImgLoad()
		x=x+8
		m_wait(2)
	next
	match(w)=match(w)+hw
endfunc

//------------------------------------

func ma_disp2(hw;int)
/* マッチ表示2
	apage(GPAGE0)
	x=(24-(hw*4)+80)+80*basyo
	for i=1 to hw
		bitmapPut(x,70,x+7,101,ma)
		bitmapImgLoad()
		x=x+8
	next
endfunc

//------------------------------------

func ma_kesu1(w;int,hw;int)
/* マッチを消す1
	apage(GPAGE0)
	match(w)=match(w)-hw
	x=match(w)*8+105
	y=w*48+317
	for i=1 to hw
		m_play(2)
		fill16X68(x,y,x+7,y+31,0)
		m_wait(2)
		x=x+8
	next
	if match(w)<0 then match(w)=0
endfunc

//------------------------------------

func ma_kesu2(w;int)
/* マッチを消す2
	apage(GPAGE0)
	x=w*80+80
	fill16X68(x,70,x+80,101,0)
endfunc

//------------------------------------

func shuffle()
/* シャッフル
int i,a,b,k
	for i=0 to 99
		a=rnd()*40
		b=rnd()*40
		k=card(a):card(a)=card(b):card(b)=k
	next
endfunc

//------------------------------------

func jqk_cut()
/* J,Q,Kを抜く
int i,c=0,d=0
dim int jqk(9)={11,12,13,24,25,26,37,38,39}
	for i=1 to 49
		if i=jqk(c) then c=c+1:continue
		card(d)=i
		d=d+1
	next
endfunc

//------------------------------------

func you_oya(sw;int)
/* 親にバーを表示
	apage(GPAGE2)
	y=oya*48+317
	fill16X68(4,y-2,504,y+34,sw)
endfunc

//------------------------------------

func myself(w;int,sw;int)
/* バー表示
int y,yy
	apage(GPAGE2)
	y=jun(w)*48+324
	if w<>0 then {
		yy=jun(w-1)*48+324
		fill16X68(12,yy,92,yy+15,0)
	}
	if sw=1 then fill16X68(12,y,92,y+15,15)
endfunc

//------------------------------------

func ura(x;int,y;int)
/* カードを裏返しに置く
	cardPut(x,y,0,NO)
endfunc

//------------------------------------

func int conv(v;int)
/* コンバート
	return(v-(v\13)*13)
endfunc

//------------------------------------

func init()
/* 変数初期化&画面初期化
	zero=0:fin=1
	for i=0 to  3:wh(i)  =-1:next
	for i=0 to 15:hand(i)=0 :next
	for i=0 to 2
		apage(GPAGE0+i):fill16X68(0,20,511,314,0)
	next
endfunc

//------------------------------------

func prep()
/* 準備
	srand(val(mid$(time$,4,2)+right$(time$,2)))
	vpageX68(15)
	apage(GPAGE3)
	fill16X68(3,0,4,31,13)
	fill16X68(3,0,4, 3, 5)
	bitmapGet(0,0,7,31,ma)
	int x1=362,x2=413
	if not isLocalizeJapan() then {
		x1=362-8*2
		x2=413-8*2-4
	}
	flbx(0,0,511,511,8,9)
	str kabu=localizedString("オイチョカブ","The SuperKABU")
	sym(x1  , 8,kabu,2, 0)
	sym(x1-2, 6,kabu,2,15)
	kabu=localizedString("親","Dealer")
	sym(x2  ,72,kabu,2, 0)
	sym(x2-2,70,kabu,2,13)

	apage(GPAGE1)
	for i=0 to 3
		sym(20,i*48+324,nam(i),1,co(i))
	next
	// マッチの縦区切り線
	for x=104 to 510
		line16X68(x,317,x,496,14)
		x=x+39
	next
	// 初期のマッチ表示
	for i=0 to 3
		match(i)=0
		ma_disp1(i,10)
	next
endfunc

//------------------------------------

func click()
/* タップされるまで待つ
//locate(0,31):print "click"
	//repeat:msstat(n,n,bl,br):until bl+br<>0
	bl=0:br=0

	// 前のタップが残っていたら、一旦離すまで待つ
	while getTouchStatus()<>TOUCH_NONE
	endwhile

	// タッチされるまで待つ
	repeat
	until getTouchStatus()<>TOUCH_NONE
	
	bl=1:// 念のため
//locate(0,31):print "     "
endfunc

//------------------------------------

func sym(x;int,y;int,s;str,z;float,c;int)
/* シンボリック
	if z=2 then z=1.5
	symbol16X68(x,y,s,z,c,FONT,FNTSZ)
endfunc

//------------------------------------

func flbx(x0;int,y0;int,xl;int,yl;int,c0;int,c1;int)
/* フィル＆ボックス
	fill16X68(x0,y0,xl,yl,c0)
	box16X68( x0,y0,xl,yl,c1)
endfunc

//------------------------------------

func m_play(ch;int)
	a_play(snd(ch))
endfunc

func m_wait(ch;int)
/* ウエイト
	repeat:until a_stat(snd(ch))=0
endfunc

//------------------------------------

func cwait(ch;int)
/* ウエイト
/* X68での実測値から
	switch ch
		case 1:wait(0.05):break
		case 2:wait(0.25):break
		case 3:wait(1):break
		case 4:wait(2):break
	endswitch
endfunc

//****************************************************************
// 補助関数
//****************************************************************

func removeKeys()
// 全タッチアリアの解除 / release all key touch area
// 毎回変わるので重要 / Important because stage is changed every time
	if touchallcnt>0 then {
		int i
		for i=1 to touchallcnt
			removeTouchArea(touchNo(i))
		next
		touchallcnt=0:// 登録してないの印
	}:// すでに解除済みの時は何もしない / if already released, do nothing.
endfunc

//****************************************************************
